'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.Type = undefined;

var _base = require('./base.js');

var _error = require('../jungle/error.js');

class Type extends _base.Ast {
  constructor(location, name) {
    super(location);
    this.name = name;
  }

  setName(name) {
    if (this.name && this.name !== name) throw new _error.JungleError('Impossible de créer un type avec deux noms : ' + name + ' / ' + this.name, this.location);

    this.name = name;

    return this;
  }

  toString() {
    return this.name;
  }

  create() {
    throw new Error('Cannot create a ' + this.name + ': missing create()');
  }

  isCompatibleWith(type) {
    return this === type;
  }
}
exports.Type = Type;