'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.Lexer = undefined;

var _ast = require('./ast');

var ast = _interopRequireWildcard(_ast);

var _lexer = require('./jungle/lexer.js');

var _symbol = require('./jungle/symbol.js');

var _error = require('./jungle/error.js');

function _interopRequireWildcard(obj) { if (obj && obj.__esModule) { return obj; } else { var newObj = {}; if (obj != null) { for (var key in obj) { if (Object.prototype.hasOwnProperty.call(obj, key)) newObj[key] = obj[key]; } } newObj.default = obj; return newObj; } }

class Lexer extends _lexer.Lexer {
  constructor(str) {
    super(str);

    this.registerRule('algorithme', this.lex_1, 'default');
    this.registerRule('fonction', this.lex_2, 'default');
    this.registerRule('procedure', this.lex_3, 'default');
    this.registerRule('parametres locaux', this.lex_4, 'default');
    this.registerRule('parametres globaux', this.lex_5, 'default');
    this.registerRule('constantes', this.lex_6, 'default');
    this.registerRule('variables', this.lex_7, 'default');
    this.registerRule('types', this.lex_8, 'default');
    this.registerRule('enregistrement', this.lex_9, 'default');
    this.registerRule('debut', this.lex_10, 'default');
    this.registerRule('fin', this.lex_11, 'default');
    this.registerRule('si', this.lex_12, 'default');
    this.registerRule('alors', this.lex_13, 'default');
    this.registerRule('sinon', this.lex_14, 'default');
    this.registerRule('pour', this.lex_15, 'default');
    this.registerRule('jusqu\'a', this.lex_16, 'default');
    this.registerRule('decroissant', this.lex_17, 'default');
    this.registerRule('faire', this.lex_18, 'default');
    this.registerRule('tant que', this.lex_19, 'default');
    this.registerRule('selon', this.lex_20, 'default');
    this.registerRule('cas', this.lex_21, 'default');
    this.registerRule('autrement', this.lex_22, 'default');
    this.registerRule('nul', this.lex_23, 'default');
    this.registerRule('"', this.lex_24, 'default');
    this.registerRule(new RegExp('[0-9]+'), this.lex_25, 'default');
    this.registerRule(new RegExp('[0-9]*\\.[0-9]+'), this.lex_26, 'default');
    this.registerRule(new RegExp('\'(.)\''), this.lex_27, 'default');
    this.registerRule('\'\\n\'', this.lex_28, 'default');
    this.registerRule('←', this.lex_29, 'default');
    this.registerRule('<-', this.lex_30, 'default');
    this.registerRule('↑', this.lex_31, 'default');
    this.registerRule('^', this.lex_32, 'default');
    this.registerRule('.', this.lex_33, 'default');
    this.registerRule('[', this.lex_34, 'default');
    this.registerRule(']', this.lex_35, 'default');
    this.registerRule('=', this.lex_36, 'default');
    this.registerRule('<>', this.lex_37, 'default');
    this.registerRule('<', this.lex_38, 'default');
    this.registerRule('<=', this.lex_39, 'default');
    this.registerRule('>=', this.lex_40, 'default');
    this.registerRule('>', this.lex_41, 'default');
    this.registerRule('non', this.lex_42, 'default');
    this.registerRule('et', this.lex_43, 'default');
    this.registerRule('ou', this.lex_44, 'default');
    this.registerRule('oue', this.lex_45, 'default');
    this.registerRule('+', this.lex_46, 'default');
    this.registerRule('-', this.lex_47, 'default');
    this.registerRule('*', this.lex_48, 'default');
    this.registerRule('/', this.lex_49, 'default');
    this.registerRule('div', this.lex_50, 'default');
    this.registerRule('mod', this.lex_51, 'default');
    this.registerRule(',', this.lex_52, 'default');
    this.registerRule(':', this.lex_53, 'default');
    this.registerRule('(', this.lex_54, 'default');
    this.registerRule(')', this.lex_55, 'default');
    this.registerRule('/*', this.lex_56, 'default');
    this.registerRule(new RegExp('[a-zA-Z_][a-zA-Z0-9_]*'), this.lex_57, 'default');
    this.registerRule('\\\n', this.lex_58, 'default');
    this.registerRule('\n', this.lex_59, 'default');
    this.registerRule(new RegExp('\\s'), this.lex_60, 'default');
    this.registerRule(new RegExp('.'), this.lex_61, 'default');
    this.registerRule('/*', this.lex_62, 'comment');
    this.registerRule('*/', this.lex_63, 'comment');
    this.registerRule(new RegExp('.|\\n'), this.lex_64, 'comment');
    this.registerRule('\\n', this.lex_65, 'dbstring');
    this.registerRule(new RegExp('\\\\([\\\\"])'), this.lex_66, 'dbstring');
    this.registerRule('"', this.lex_67, 'dbstring');
    this.registerRule(new RegExp('.'), this.lex_68, 'dbstring');
    this.registerRule(new RegExp('\\s+'), this.lex_69, 'linefeed');
    this.registerRule('/*', this.lex_70, 'linefeed');
    this.registerRule(new RegExp('.|$'), this.lex_71, 'linefeed');
  }

  lex_1(__match__, __token__) {
    const __str__ = __match__[0];
    __token__.sy.type = _symbol.LngSymbol.token;

    __token__.sy.name = 'algorithme';

    return true;
  }
  lex_2(__match__, __token__) {
    const __str__ = __match__[0];
    __token__.sy.type = _symbol.LngSymbol.token;

    __token__.sy.name = 'fonction';

    return true;
  }
  lex_3(__match__, __token__) {
    const __str__ = __match__[0];
    __token__.sy.type = _symbol.LngSymbol.token;

    __token__.sy.name = 'procedure';

    return true;
  }
  lex_4(__match__, __token__) {
    const __str__ = __match__[0];
    __token__.sy.type = _symbol.LngSymbol.token;

    __token__.sy.name = 'parametres locaux';

    return true;
  }
  lex_5(__match__, __token__) {
    const __str__ = __match__[0];
    __token__.sy.type = _symbol.LngSymbol.token;

    __token__.sy.name = 'parametres globaux';

    return true;
  }
  lex_6(__match__, __token__) {
    const __str__ = __match__[0];
    __token__.sy.type = _symbol.LngSymbol.token;

    __token__.sy.name = 'constantes';

    return true;
  }
  lex_7(__match__, __token__) {
    const __str__ = __match__[0];
    __token__.sy.type = _symbol.LngSymbol.token;

    __token__.sy.name = 'variables';

    return true;
  }
  lex_8(__match__, __token__) {
    const __str__ = __match__[0];
    __token__.sy.type = _symbol.LngSymbol.token;

    __token__.sy.name = 'types';

    return true;
  }
  lex_9(__match__, __token__) {
    const __str__ = __match__[0];
    __token__.sy.type = _symbol.LngSymbol.token;

    __token__.sy.name = 'enregistrement';

    return true;
  }
  lex_10(__match__, __token__) {
    const __str__ = __match__[0];
    __token__.sy.type = _symbol.LngSymbol.token;

    __token__.sy.name = 'debut';

    return true;
  }
  lex_11(__match__, __token__) {
    const __str__ = __match__[0];
    __token__.sy.type = _symbol.LngSymbol.token;

    __token__.sy.name = 'fin';

    return true;
  }
  lex_12(__match__, __token__) {
    const __str__ = __match__[0];
    __token__.sy.type = _symbol.LngSymbol.token;

    __token__.sy.name = 'si';

    return true;
  }
  lex_13(__match__, __token__) {
    const __str__ = __match__[0];
    __token__.sy.type = _symbol.LngSymbol.token;

    __token__.sy.name = 'alors';

    return true;
  }
  lex_14(__match__, __token__) {
    const __str__ = __match__[0];
    __token__.sy.type = _symbol.LngSymbol.token;

    __token__.sy.name = 'sinon';

    return true;
  }
  lex_15(__match__, __token__) {
    const __str__ = __match__[0];
    __token__.sy.type = _symbol.LngSymbol.token;

    __token__.sy.name = 'pour';

    return true;
  }
  lex_16(__match__, __token__) {
    const __str__ = __match__[0];
    __token__.sy.type = _symbol.LngSymbol.token;

    __token__.sy.name = 'jusqu\'a';

    return true;
  }
  lex_17(__match__, __token__) {
    const __str__ = __match__[0];
    __token__.sy.type = _symbol.LngSymbol.token;

    __token__.sy.name = 'decroissant';

    return true;
  }
  lex_18(__match__, __token__) {
    const __str__ = __match__[0];
    __token__.sy.type = _symbol.LngSymbol.token;

    __token__.sy.name = 'faire';

    return true;
  }
  lex_19(__match__, __token__) {
    const __str__ = __match__[0];
    __token__.sy.type = _symbol.LngSymbol.token;

    __token__.sy.name = 'tant que';

    return true;
  }
  lex_20(__match__, __token__) {
    const __str__ = __match__[0];
    __token__.sy.type = _symbol.LngSymbol.token;

    __token__.sy.name = 'selon';

    return true;
  }
  lex_21(__match__, __token__) {
    const __str__ = __match__[0];
    __token__.sy.type = _symbol.LngSymbol.token;

    __token__.sy.name = 'cas';

    return true;
  }
  lex_22(__match__, __token__) {
    const __str__ = __match__[0];
    __token__.sy.type = _symbol.LngSymbol.token;

    __token__.sy.name = 'autrement';

    return true;
  }
  lex_23(__match__, __token__) {
    const __str__ = __match__[0];
    __token__.sy.type = _symbol.LngSymbol.token;

    __token__.sy.name = 'nul';

    return true;
  }
  lex_24(__match__, __token__) {
    const __str__ = __match__[0];
    __token__.sy.type = _symbol.LngSymbol.token;

    this.pushScope('dbstring');__token__.val = '';return false;
  }
  lex_25(__match__, __token__) {
    const __str__ = __match__[0];
    __token__.sy.type = _symbol.LngSymbol.token;

    __token__.val = +__match__[0];__token__.sy.name = 'entier';return true;
  }
  lex_26(__match__, __token__) {
    const __str__ = __match__[0];
    __token__.sy.type = _symbol.LngSymbol.token;

    __token__.val = +__match__[0];__token__.sy.name = 'reel';return true;
  }
  lex_27(__match__, __token__) {
    const __str__ = __match__[0];
    __token__.sy.type = _symbol.LngSymbol.token;

    __token__.val = __match__[1];
    __token__.sy.name = 'caractere';

    return true;
  }
  lex_28(__match__, __token__) {
    const __str__ = __match__[0];
    __token__.sy.type = _symbol.LngSymbol.token;

    __token__.val = '\n';__token__.sy.name = 'caractere';return true;
  }
  lex_29(__match__, __token__) {
    const __str__ = __match__[0];
    __token__.sy.type = _symbol.LngSymbol.token;

    __token__.sy.name = '←';

    return true;
  }
  lex_30(__match__, __token__) {
    const __str__ = __match__[0];
    __token__.sy.type = _symbol.LngSymbol.token;

    __token__.sy.name = '←';

    return true;
  }
  lex_31(__match__, __token__) {
    const __str__ = __match__[0];
    __token__.sy.type = _symbol.LngSymbol.token;

    __token__.sy.name = '↑';

    return true;
  }
  lex_32(__match__, __token__) {
    const __str__ = __match__[0];
    __token__.sy.type = _symbol.LngSymbol.token;

    __token__.sy.name = '↑';

    return true;
  }
  lex_33(__match__, __token__) {
    const __str__ = __match__[0];
    __token__.sy.type = _symbol.LngSymbol.token;

    __token__.sy.name = '.';

    return true;
  }
  lex_34(__match__, __token__) {
    const __str__ = __match__[0];
    __token__.sy.type = _symbol.LngSymbol.token;

    __token__.sy.name = '[';

    return true;
  }
  lex_35(__match__, __token__) {
    const __str__ = __match__[0];
    __token__.sy.type = _symbol.LngSymbol.token;

    __token__.sy.name = ']';

    return true;
  }
  lex_36(__match__, __token__) {
    const __str__ = __match__[0];
    __token__.sy.type = _symbol.LngSymbol.token;

    __token__.sy.name = '=';

    return true;
  }
  lex_37(__match__, __token__) {
    const __str__ = __match__[0];
    __token__.sy.type = _symbol.LngSymbol.token;

    __token__.sy.name = '<>';

    return true;
  }
  lex_38(__match__, __token__) {
    const __str__ = __match__[0];
    __token__.sy.type = _symbol.LngSymbol.token;

    __token__.sy.name = '<';

    return true;
  }
  lex_39(__match__, __token__) {
    const __str__ = __match__[0];
    __token__.sy.type = _symbol.LngSymbol.token;

    __token__.sy.name = '<=';

    return true;
  }
  lex_40(__match__, __token__) {
    const __str__ = __match__[0];
    __token__.sy.type = _symbol.LngSymbol.token;

    __token__.sy.name = '>=';

    return true;
  }
  lex_41(__match__, __token__) {
    const __str__ = __match__[0];
    __token__.sy.type = _symbol.LngSymbol.token;

    __token__.sy.name = '>';

    return true;
  }
  lex_42(__match__, __token__) {
    const __str__ = __match__[0];
    __token__.sy.type = _symbol.LngSymbol.token;

    __token__.sy.name = 'non';

    return true;
  }
  lex_43(__match__, __token__) {
    const __str__ = __match__[0];
    __token__.sy.type = _symbol.LngSymbol.token;

    __token__.sy.name = 'et';

    return true;
  }
  lex_44(__match__, __token__) {
    const __str__ = __match__[0];
    __token__.sy.type = _symbol.LngSymbol.token;

    __token__.sy.name = 'ou';

    return true;
  }
  lex_45(__match__, __token__) {
    const __str__ = __match__[0];
    __token__.sy.type = _symbol.LngSymbol.token;

    __token__.sy.name = 'oue';

    return true;
  }
  lex_46(__match__, __token__) {
    const __str__ = __match__[0];
    __token__.sy.type = _symbol.LngSymbol.token;

    __token__.sy.name = '+';

    return true;
  }
  lex_47(__match__, __token__) {
    const __str__ = __match__[0];
    __token__.sy.type = _symbol.LngSymbol.token;

    __token__.sy.name = '-';

    return true;
  }
  lex_48(__match__, __token__) {
    const __str__ = __match__[0];
    __token__.sy.type = _symbol.LngSymbol.token;

    __token__.sy.name = '*';

    return true;
  }
  lex_49(__match__, __token__) {
    const __str__ = __match__[0];
    __token__.sy.type = _symbol.LngSymbol.token;

    __token__.sy.name = '/';

    return true;
  }
  lex_50(__match__, __token__) {
    const __str__ = __match__[0];
    __token__.sy.type = _symbol.LngSymbol.token;

    __token__.sy.name = 'div';

    return true;
  }
  lex_51(__match__, __token__) {
    const __str__ = __match__[0];
    __token__.sy.type = _symbol.LngSymbol.token;

    __token__.sy.name = 'mod';

    return true;
  }
  lex_52(__match__, __token__) {
    const __str__ = __match__[0];
    __token__.sy.type = _symbol.LngSymbol.token;

    __token__.sy.name = ',';

    return true;
  }
  lex_53(__match__, __token__) {
    const __str__ = __match__[0];
    __token__.sy.type = _symbol.LngSymbol.token;

    __token__.sy.name = ':';

    return true;
  }
  lex_54(__match__, __token__) {
    const __str__ = __match__[0];
    __token__.sy.type = _symbol.LngSymbol.token;

    __token__.sy.name = '(';

    return true;
  }
  lex_55(__match__, __token__) {
    const __str__ = __match__[0];
    __token__.sy.type = _symbol.LngSymbol.token;

    __token__.sy.name = ')';

    return true;
  }
  lex_56(__match__, __token__) {
    const __str__ = __match__[0];
    __token__.sy.type = _symbol.LngSymbol.token;

    __token__.sy.name = '/*';

    this.pushScope('comment');

    return false;
  }
  lex_57(__match__, __token__) {
    const __str__ = __match__[0];
    __token__.sy.type = _symbol.LngSymbol.token;

    __token__.sy.name = 'identifieur';__token__.val = __match__[0].toLowerCase();return true;
  }
  lex_58(__match__, __token__) {
    const __str__ = __match__[0];
    __token__.sy.type = _symbol.LngSymbol.token;

    __token__.sy.name = '\\\n';

    return false;
  }
  lex_59(__match__, __token__) {
    const __str__ = __match__[0];
    __token__.sy.type = _symbol.LngSymbol.token;

    __token__.sy.name = '\n';

    this.pushScope('linefeed');

    return false;
  }
  lex_60(__match__, __token__) {
    const __str__ = __match__[0];
    __token__.sy.type = _symbol.LngSymbol.token;

    return false;
  }
  lex_61(__match__, __token__) {
    const __str__ = __match__[0];
    __token__.sy.type = _symbol.LngSymbol.token;

    throw new _error.JungleError('Caractère $0 invalide'.replace("$0", __match__[0]), __token__.location);

    return false;
  }
  lex_62(__match__, __token__) {
    const __str__ = __match__[0];
    __token__.sy.type = _symbol.LngSymbol.token;

    __token__.sy.name = '/*';

    this.pushScope('comment');

    return false;
  }
  lex_63(__match__, __token__) {
    const __str__ = __match__[0];
    __token__.sy.type = _symbol.LngSymbol.token;

    __token__.sy.name = '*/';

    this.popScope();

    return false;
  }
  lex_64(__match__, __token__) {
    const __str__ = __match__[0];
    __token__.sy.type = _symbol.LngSymbol.token;

    return false;
  }
  lex_65(__match__, __token__) {
    const __str__ = __match__[0];
    __token__.sy.type = _symbol.LngSymbol.token;

    __token__.val += '\n';return false;
  }
  lex_66(__match__, __token__) {
    const __str__ = __match__[0];
    __token__.sy.type = _symbol.LngSymbol.token;

    __token__.val += __match__[1];return false;
  }
  lex_67(__match__, __token__) {
    const __str__ = __match__[0];
    __token__.sy.type = _symbol.LngSymbol.token;

    __token__.sy.name = 'chaine';this.popScope();return true;
  }
  lex_68(__match__, __token__) {
    const __str__ = __match__[0];
    __token__.sy.type = _symbol.LngSymbol.token;

    __token__.val += __match__[0];return false;
  }
  lex_69(__match__, __token__) {
    const __str__ = __match__[0];
    __token__.sy.type = _symbol.LngSymbol.token;

    return false;
  }
  lex_70(__match__, __token__) {
    const __str__ = __match__[0];
    __token__.sy.type = _symbol.LngSymbol.token;

    __token__.sy.name = '/*';

    this.pushScope('comment');

    return false;
  }
  lex_71(__match__, __token__) {
    const __str__ = __match__[0];
    __token__.sy.type = _symbol.LngSymbol.token;

    __token__.sy.name = '\n';

    this.popScope();
    this.move(0);
    return true;
  }
}
exports.Lexer = Lexer;