'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.Entier = undefined;

var _ast = require('../ast');

var ast = _interopRequireWildcard(_ast);

var _types = require('../types');

var types = _interopRequireWildcard(_types);

var _error = require('../jungle/error.js');

function _interopRequireWildcard(obj) { if (obj && obj.__esModule) { return obj; } else { var newObj = {}; if (obj != null) { for (var key in obj) { if (Object.prototype.hasOwnProperty.call(obj, key)) newObj[key] = obj[key]; } } newObj.default = obj; return newObj; } }

class Entier extends ast.Function {
  constructor(entier) {
    super(null, 'entier', entier, new ast.Routine(new ast.Parameters([], []), [], [], []), []);
  }

  checkParameters(args) {
    if (args.length !== 1) throw new Error('entier prend un seul paramètre et non ' + args.length);

    const argType = args[0].resType;

    if (!(argType instanceof types.Entier || argType instanceof types.Reel || argType instanceof types.Caractere)) throw new _error.JungleError('cet argument ne peut pas être transformé en entier', args[0].location);

    return true;
  }

  execute(executor, params) {
    if (params[0].type instanceof types.Caractere) return this.createReturn(this.type.create(params[0].value.charCodeAt(0)));
    return this.createReturn(this.type.create(params[0].value));
  }
}
exports.Entier = Entier;