import {Type} from './type.js'

export class Array extends Type {
  constructor(type, dimensions) {
    super()
    this.type = type
    this.dimensions = dimensions
  }

  create(...rest) {
    return this.createDimensions(this.dimensions, ...rest)
  }

  createDimensions(dimensions, ...rest) {
    if (!dimensions.length)
      return this.type.create(...rest)

    const dimension = dimensions[0]
    dimensions = dimensions.slice(1)

    const res = []
    for (let i = 0; i < dimension; ++i)
      res.push(rest.length ? this.createDimensions(dimensions, rest[0][i]) : this.createDimensions(dimensions))

    return res
  }
}
