import {JungleError} from '../jungle/error.js'

export class Ast {
  constructor(location) {
    this.location = location
  }

  setLocation(location) {
    this.location = location
    return this
  }

  accept(visitor) {
    if (!('visit' + this.constructor.name in visitor))
      throw new Error('Your visitor must implement visit' + this.constructor.name + '(ast)')
    try {
      return visitor['visit' + this.constructor.name](this)
    }
    catch (err) {
      if (err instanceof JungleError && !err.location && this.location)
        err.location = this.location
      throw err
    }
  }
}
