import {Type} from './type.js'

export class Record extends Type {
  constructor(name, properties) {
    super(null, name)
    this.properties = properties
  }

  create(record) {
    if (record)
      return this.copy(record)

    return this.properties.reduce((acc, variables) => {
      variables.names.forEach(name => acc[name] = variables.type.create())
      return acc
    }, {})
  }

  copy(record) {
    const res = {}
    for (let val in record)
      res[val] = this.properties.find(prop => prop.names.indexOf(val) >= 0).type.create(record[val])
    return res
  }
}
