import {Ast} from './base.js'
import {JungleError} from '../jungle/error.js'

export class Type extends Ast {
  constructor(location, name) {
    super(location)
    this.name = name
  }

  setName(name) {
    if (this.name && this.name !== name)
      throw new JungleError('Impossible de créer un type avec deux noms : ' + name + ' / ' + this.name, this.location)

    this.name = name

    return this
  }

  toString() {
    return this.name
  }

  create() {
    throw new Error('Cannot create a ' + this.name + ': missing create()')
  }

  isCompatibleWith(type) {
    return this === type
  }
}
