import * as ast from '../ast'
import * as types from '../types'
import {JungleError} from '../jungle/error.js'

export class Caractere extends ast.Function {
  constructor(caractere) {
    super(null, 'caractere', caractere, new ast.Routine(new ast.Parameters([], []), [], [], []), [])
  }

  checkParameters(args) {
    if (args.length !== 1)
      throw new Error('caractere prend un seul paramètre et non ' + args.length)

    const argType = args[0].resType

    if (!(argType instanceof types.Entier || argType instanceof types.Caractere))
      throw new JungleError('cet argument ne peut pas être transformé en caractere', args[0].location)

    return true
  }

  execute(executor, params) {
    if (params[0].type instanceof types.Entier)
      return this.createReturn(this.type.create(String.fromCharCode(params[0].value)))
    return this.createReturn(this.type.create(params[0].value))
  }
}
