import * as ast from '../ast'
import * as types from '../types'
import {JungleError} from '../jungle/error.js'

export class Chaine extends ast.Function {
  constructor(chaine) {
    super(null, 'chaine', chaine, new ast.Routine(new ast.Parameters([], []), [], [], []), [])
  }

  checkParameters(args) {
    if (args.length !== 1)
      throw new JungleError('chaine prend un seul paramètre et non ' + args.length)

    const argType = args[0].resType

    if (!(argType instanceof types.Entier || argType instanceof types.Reel ||
      argType instanceof types.Caractere || argType instanceof types.Chaine))
      throw new JungleError('cet argument ne peut pas être transformé en chaine', args[0].location)

    return true
  }

  execute(executor, params) {
    return this.createReturn(this.type.create('' + params[0].value))
  }
}
