import * as ast from '../ast'
import * as types from '../types'
import {JungleError} from '../jungle/error.js'

export class Entier extends ast.Function {
  constructor(entier) {
    super(null, 'entier', entier, new ast.Routine(new ast.Parameters([], []), [], [], []), [])
  }

  checkParameters(args) {
    if (args.length !== 1)
      throw new Error('entier prend un seul paramètre et non ' + args.length)

    const argType = args[0].resType

    if (!(argType instanceof types.Entier || argType instanceof types.Reel || argType instanceof types.Caractere))
      throw new JungleError('cet argument ne peut pas être transformé en entier', args[0].location)

    return true
  }

  execute(executor, params) {
    if (params[0].type instanceof types.Caractere)
      return this.createReturn(this.type.create(params[0].value.charCodeAt(0)))
    return this.createReturn(this.type.create(params[0].value))
  }
}
