import * as ast from '../ast'
import {JungleError} from '../jungle/error.js'

export class Liberer extends ast.Procedure
{
  constructor() {
    super(null, 'liberer', null, [])
  }

  checkParameters(args) {
    if (args.length !== 1)
      throw new JungleError('liberer prend un seul paramètre et non ' + args.length)

    if (!(args[0].resType instanceof ast.Pointer))
      throw new JungleError('liberer prend un paramètre de type pointeur et non un ' + args[0].resType, args[0].location)

    return true
  }

  execute(executor, params) {
    if (params.value === 0)
      return
    if (!(params[0].value in executor.heap))
      throw new JungleError('Segmentation fault')
    delete executor.heap[params[0].value]
    params[0].value = 0
  }
}
